module account_server

import StdEnv, ArgEnv
import Corba

import account

import RWSDebug, Debug

////////////////////////////////
//          MAIN
////////////////////////////////

Start w
	# (orb,_,w)		= CORBA_ORB_init args w
	= CORBA_Server_run orb Void ServerInit w
where
	args2 = getCommandLine
	argc = size args2 - 1
	args = [ args2.[i] \\ i <- [0..argc] ]	
	ServerInit ps w
		# (obj, ps, w)  = Account__servant_open ps servant w
		# w				= WriteIORToFile (CORBA_Server_get_orb ps) obj "account.ior" w
		= (ps, w)
	servant = { Account__servant |
			ls 				= 0,
			impl_deposit	= my_deposit,
			impl_withdraw	= my_withdraw,
			impl_balance	= my_balance
			}

	my_deposit (ls, ps) what w
		= ((ls + what, ps), Result Void, w)

	my_withdraw (ls, ps) what w
		= ((ls - what, ps), Result Void, w)

	my_balance (ls, ps) w
		= ((ls, ps), Result ls, w)


// Local Variables:
// tab-width: 4
// End:




