#ifdef CLEAN_ORB_MICO
#define MICO_CONF_POA 
#include <CORBA-SMALL.h>
#endif

#ifdef CLEAN_ORB_ORBACUS
#include <OB/CORBA.h>
#endif

#include <iostream.h>
#include <fstream.h>
#include <unistd.h>
#include "test.h"

#ifdef CLEAN_ORB_ORBACUS
#include "test_skel.h"
#endif

PortableServer::POA_ptr the_poa;

/*
 * Useless implementation
 */

class Useless_impl : virtual public POA_Useless {
    CORBA::Long _current_balance;
    CORBA::Long _calls;
  char * attr_value;
public:

  Useless_impl() {
    _current_balance = 0;
    attr_value = CORBA::string_dup("bubu");
  }

  virtual char* an_attribute() {
    return (CORBA::string_dup(attr_value));
  }

  virtual void an_attribute( const char* value ) {
    delete[] attr_value;
    attr_value = CORBA::string_dup(value);
  }

    void deposit( CORBA::ULong amount )
    {
      cout << "deposit() called with " << amount << endl;
        _current_balance += amount;
    }

    void withdraw( CORBA::ULong amount )
    {
        _current_balance -= amount;
    }
    
  CORBA::Long balance()
    {
      cout << "balance() called." << endl;

      return _current_balance;
    }

  void balance2(CORBA::Long& amount) {
    amount = _current_balance;
  }

  char * echo(const char * what) {
    return(CORBA::string_dup(what));
  }

  CORBA::Any* echo_any( const CORBA::Any& what ) {
    cout << "echo_any() called." << endl;

    return(new CORBA::Any(what));
  }

  CORBA::TypeCode_ptr echo_tc( CORBA::TypeCode_ptr what ) {
    cout << "echo_tc() called." << endl;
    
    return(CORBA::TypeCode::_duplicate(what));
  }

  Useless_ptr self() {
    cout << "self() called." << endl;

    return(_this());
  }

  Useless_ptr echo_objref( ::Useless_ptr what ) {
    cout << "echo_objref() called." << endl;

    return(what);
  }

  Useless::Useless_struct* echo_struct( const Useless::Useless_struct& what ) {
    return(new Useless::Useless_struct(what));
  }

  Useless::Recursive_struct * echo_recursive( const Useless::Recursive_struct& what ) {
    cout << "echo_recursive() called." << endl;
     return(new Useless::Recursive_struct(what));
  }

  Useless::long_seq* echo_seq( const Useless::long_seq& what ) {
	return(new Useless::long_seq(what));
  }

  Useless::Useless_union echo_union( const Useless::Useless_union& what ) {
    return(what);
  }

  Useless::Implicit_union echo_implicit_union( const Useless::Implicit_union& what ) {
    cout << "D: " << what._d() << endl;
    return(what);
  }

  Useless::Useless_enum echo_enum( Useless::Useless_enum what ) {
    return(what);
  }

  Useless::long_array_slice* echo_array( const Useless::long_array what ) {
    //    long_array_slice * result = long_array_dup(what);
    
    return( Useless::long_array_dup(what) );
  }

  void raise_exception() {
	cout << "raise_exception() called." << endl;
    Useless::Useless_Exception ex;
    ex.member1 = 1;
    ex.member2 = 2;
    throw ex;
  }

#if MICO_BIN_VERSION >= 0x020305
  CORBA::Long test_args( const char* arg1, CORBA::String_out arg2, CORBA::Long& arg3 ) {
#else
  CORBA::Long test_args( const char* arg1, char*& arg2, CORBA::Long& arg3 ) {
#endif
    cout << "X: " << arg1 << " " << arg3 << endl;

    arg2 = CORBA::string_dup(arg1);
    arg3 = arg3 + 1;
    return arg3;
  }

};

class MyServant : virtual public PortableServer::DynamicImplementation {
  
  virtual void invoke (CORBA::ServerRequest_ptr) {
    cout << "Request received." << endl;
  }

  virtual CORBA::RepositoryId _primary_interface(const PortableServer::ObjectId& id, PortableServer::POA_ptr poa) {
    cout << "_primary_interface() called." << endl;
    return(CORBA::string_dup("IDL:Useless:1.0"));
  }
    
};

int main( int argc, char *argv[] )
{
    cout << "server init" << endl;

    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );
    CORBA::Object_var obj =
      orb->resolve_initial_references("RootPOA");
    the_poa = PortableServer::POA::_narrow(obj);
    assert(the_poa);

    PortableServer::POAManager_var mgr = the_poa->the_POAManager();
    mgr->activate();

    // Create and register an object
    Useless_impl acc;
    Useless_var object = acc._this();

	CORBA::String_var ior = orb->object_to_string(object);
	ofstream out("test.ior");
	out << ior;
	out.close();

    //    the_poa->activate_object(new MyServant);

    orb->run ();

    return 0;
}
