module test_server

import StdEnv, ArgEnv
import Corba

import test

import RWSDebug, Debug

////////////////////////////////
//          MAIN
////////////////////////////////

Start w
	# (orb,_,w)		= CORBA_ORB_init args w
	= CORBA_Server_run orb Void ServerInit w
where
	args2 = getCommandLine
	argc = size args2 - 1
	args = [ args2.[i] \\ i <- [0..argc] ]	
	ServerInit ps w
		# (obj, ps, w)  = Useless__servant_open ps servant w
		# w				= WriteIORToFile (CORBA_Server_get_orb ps) obj "test.ior" w
		= (ps, w)
	servant = { Useless__servant |
			ls 				= 0,
			impl_echo 		= my_echo,
			impl_deposit	= my_deposit,
			impl_withdraw	= my_withdraw,
			impl_balance	= my_balance,
			impl_balance2	= my_balance2,
			impl_echo_any	= my_echo,
			impl_echo_tc	= my_echo,
			impl_self		= my_self,
			impl_echo_objref= my_echo,
			impl_echo_struct= my_echo,
			impl_echo_recursive = my_echo,
			impl_echo_seq	= my_echo,
			impl_echo_union	= my_echo,
			impl_echo_implicit_union = my_echo,
			impl_echo_enum	= my_echo,
			impl_echo_array	= my_echo,
			impl_raise_exception = my_raise_exception,
			impl_test_args	= my_test_args,
			impl__get_an_attribute	= my_get_an_attribute,
			impl__set_an_attribute	= my_set_an_attribute
			}

	my_deposit (ls, ps) what w
		= ((ls + what, ps), Result Void, w) <<- "my_deposit"

	my_withdraw (ls, ps) what w
		= ((ls - what, ps), Result Void, w) <<- "my_withdraw"

	my_balance (ls, ps) w
		= ((ls, ps), Result ls, w) <<- "my_balance"

	my_balance2 (ls, ps) w
		= ((ls, ps), Result (Void, ls), w)

	my_echo (ls, ps) what w
		= ((ls, ps), Result what, w)	<<-	"my_echo"

	my_echo_any (ls, ps) what w
		= ((ls, ps), Result what, w)

	my_echo_tc (ls, ps) what w
		= ((ls, ps), Result what, w)

	// TODO
	my_self (ls, ps) w
		# (Just this, w)	= Useless__narrow (CORBA_Server_get_current ps) w
		= ((ls, ps), Result this, w)

	// TODO
	my_raise_exception (ls, ps) w
		= ((ls, ps), Exception ex, w)
	where
		ex = UserException Useless_Useless_Exception__repoid (Useless_Useless_Exception__encode { member1 = 1, member2 = 2 })

	my_test_args (ls, ps) arg1 arg3 w
		= ((ls, ps), Result (arg3, arg1, arg3 + 1), w)

	my_get_an_attribute (ls, ps) w
		= ((ls, ps), Result "foo", w)

	my_set_an_attribute (ls, ps) value w
		= ((ls, ps), Result Void, w)
		







// Local Variables:
// tab-width: 4
// End:




